import processing.core.PApplet;
import java.awt.*;
import java.util.LinkedList;
import java.util.Queue;

public class GameLogic extends PApplet {

    public static void main(String[] args) {
        PApplet.main("GameLogic");
    }

    private Queue<int[]> trail = new LinkedList<>();
    private Point testPoint = new Point(200, 200);

    public void settings() {
        size(800, 600);
    }

    public void setup() {
        noLoop(); // Zeichnen nur bei Bedarf
        fillTrail(); // Beispielpfad erstellen
        //boolean collision = doCheck(trail, testPoint);
        System.out.println("Collision detected: ");
    }

    private void fillTrail() {
        // Beispielhafte Füllung der Spur
        for (int i = 0; i < 100; i++) {
            trail.add(new int[]{50 + i * 5, 300}); // Punkte entlang der x-Achse
        }
    }

    public boolean doCheckExtern(Queue<int[]> trail, Point point){
        return doCheck(trail, point);
    }

    public boolean doCheck(Queue<int[]> trail, Point point) {
        int particleSize = 10;

        // Zeichne den Pfad auf das Canvas
        background(255); // Weißer Hintergrund
        for (int[] coordinates : new LinkedList<>(trail)) {
            int x = coordinates[0];
            int y = coordinates[1];
            fill(0); // Schwarz
            rect(x, y, particleSize, particleSize);
        }

        // Überprüfe die Pixelwerte am Testpunkt
        int c = get(point.x, point.y); // Farbwert abrufen
        return (c == color(0)); // Schwarz bedeutet Kollision
    }
}
